package com.knecon.fforesight.service.layoutparser.processor.model.graph.nodes;

import java.awt.geom.Rectangle2D;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.knecon.fforesight.service.layoutparser.internal.api.data.redaction.LayoutEngine;
import com.knecon.fforesight.service.layoutparser.internal.api.data.redaction.NodeType;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.DocumentTree;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.entity.RedactionEntity;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.textblock.TextBlock;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.FieldDefaults;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE)
public class Image implements GenericSemanticNode {

    @Builder.Default
    Set<LayoutEngine> engines = new HashSet<>(Set.of(LayoutEngine.ALGORITHM));

    List<Integer> treeId;
    String id;

    ImageType imageType;
    boolean transparent;
    Rectangle2D position;

    TextBlock leafTextBlock;

    boolean redaction;
    boolean ignored;
    @Builder.Default
    String redactionReason = "";
    @Builder.Default
    String legalBasis = "";
    @Builder.Default
    int matchedRule = -1;

    @EqualsAndHashCode.Exclude
    Page page;

    @EqualsAndHashCode.Exclude
    DocumentTree documentTree;

    @Builder.Default
    @EqualsAndHashCode.Exclude
    Set<RedactionEntity> entities = new HashSet<>();


    @Override
    public NodeType getType() {

        return NodeType.IMAGE;
    }


    @Override
    public TextBlock getTextBlock() {

        return leafTextBlock;
    }


    @Override
    public Set<Page> getPages() {

        return Collections.singleton(page);
    }


    @Override
    public String toString() {

        return treeId + ": " + NodeType.IMAGE + ": " + imageType.toString() + " " + position;
    }


    @Override
    public Map<Page, Rectangle2D> getBBox() {

        Map<Page, Rectangle2D> bBoxPerPage = new HashMap<>();
        bBoxPerPage.put(page, position);
        return bBoxPerPage;
    }


    @Override
    public boolean isLeaf() {

        return true;
    }

}
